<?php

namespace FiloBlu\ExtAmastyGeoipRedirect\Helper;

class Data extends \Magento\Framework\App\Helper\AbstractHelper {
    
    protected $_countries;
    protected $_countryFactory;
    
     public function __construct(
        \Magento\Framework\App\Helper\Context $context,
             \Magento\Directory\Model\Config\Source\Country $countries,
             \Magento\Directory\Model\CountryFactory $countryFactory
    ) {
         $this->_countries = $countries;
         $this->_countryFactory = $countryFactory;
        parent::__construct($context);
    }

    public function getAllCountries() {
        return $this->_countryFactory->create()->getCollection()->getData();
    }
    
     public function getCountryName($iso = null, $locale = null) {

        $country = $this->_countryFactory->create()->loadByCode($iso);

        return $country->getName($locale);
    }
    
     public function setCountryCookie($country) {

        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $objectManager->get('FiloBlu\ExtAmastyGeoipRedirect\Cookie\Country')
                ->set($country);
    }
    
    public function getCountryCookie() {
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        return $objectManager->get('FiloBlu\ExtAmastyGeoipRedirect\Cookie\Country')
                        ->get();
    }
    
    public function getCountryCookieName() {
        return \FiloBlu\ExtAmastyGeoipRedirect\Cookie\Country::COOKIE_NAME;
    }
    
     public function setLocalizedCountryCookie($country) {

        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $objectManager->get('FiloBlu\ExtAmastyGeoipRedirect\Cookie\LocalizedCountry')
                ->set($country);
    }
    
    public function getLocalizedCountryCookie() {
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        return $objectManager->get('FiloBlu\ExtAmastyGeoipRedirect\Cookie\LocalizedCountry')
                        ->get();
    }
    
    public function getLocalizedCountryCookieName() {
        return \FiloBlu\ExtAmastyGeoipRedirect\Cookie\LocalizedCountry::COOKIE_NAME;
    }
    
     public function setStoreCookie($storeId) {

        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $objectManager->get('FiloBlu\ExtAmastyGeoipRedirect\Cookie\Store')
                ->set($storeId);
    }
    
    public function getStoreCookie() {
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        return $objectManager->get('FiloBlu\ExtAmastyGeoipRedirect\Cookie\Store')
                        ->get();
    }
    
    public function getStoreCookieName() {
        return \FiloBlu\ExtAmastyGeoipRedirect\Cookie\Store::COOKIE_NAME;
    }
    
     public function setCurrencyCookie() {

        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $objectManager->get('FiloBlu\ExtAmastyGeoipRedirect\Cookie\Currency')
                ->set(1);
    }
    
    public function getCurrencyCookie() {
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        return $objectManager->get('FiloBlu\ExtAmastyGeoipRedirect\Cookie\Currency')
                        ->get();
    }
    
    public function getCurrencyCookieName() {
        return \FiloBlu\ExtAmastyGeoipRedirect\Cookie\Currency::COOKIE_NAME;
    }
    
     public function setUrlCookie() {

        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $objectManager->get('FiloBlu\ExtAmastyGeoipRedirect\Cookie\Url')
                ->set(1);
    }
    
    public function getUrlCookie() {
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        return $objectManager->get('FiloBlu\ExtAmastyGeoipRedirect\Cookie\Url')
                        ->get();
    }
    
    public function getUrlCookieName() {
        return \FiloBlu\ExtAmastyGeoipRedirect\Cookie\Url::COOKIE_NAME;
    }

//    public function getConfig($config_path, $section = 'filoblu_newsletter_section') {
//        return $this->scopeConfig->getValue(
//                        $section . '/' . $config_path, \Magento\Store\Model\ScopeInterface::SCOPE_STORE
//        );
//    }

}
